<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>30.10</title>

    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css"
        integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">

    <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js"
        integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct"
        crossorigin="anonymous"></script>
</head>

<body>
    <div class="container jumbotron">
        <form id="login-form">
            <div class="form-group">
                <label for="exampleInputEmail1">Email address</label>
                <input type="email" class="form-control" id="exampleInputEmail1" aria-describedby="emailHelp">
                <small id="emailHelp" class="form-text text-muted">We'll never share your email with anyone
                    else.</small>
            </div>
            <div class="form-group">
                <label for="exampleInputPassword1">Password</label>
                <input type="password" class="form-control" id="exampleInputPassword1">
            </div>
            <button type="submit" class="btn btn-primary">Submit</button>
        </form>
    </div>
</body>

<script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_STATUS_OK = 200;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";

    var gLoginFormElement = document.getElementById("login-form");

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    gLoginFormElement.addEventListener("submit", function(paramEvent) {
        // Loại bỏ mặc định của submit form
        paramEvent.preventDefault();

        callAPILogIn();
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function callAPILogIn() {
        // Thu thập dữ liệu
        var vEmailValue = document.getElementById("exampleInputEmail1").value;
        var vPasswordValue = document.getElementById("exampleInputPassword1").value;

        // Kiểm tra dữ liệu
        var vValidate = validateForm(vEmailValue, vPasswordValue);

        if(vValidate) {
            // Chuẩn bị input
            var vQueryParams = new URLSearchParams({
                email: vEmailValue,
                password: vPasswordValue
            })

            // Create a request 
            var vXMLHttpLoginRequest = new XMLHttpRequest();
            vXMLHttpLoginRequest.open("GET", gBASE_URL + "?" + vQueryParams.toString(), true);
            vXMLHttpLoginRequest.send();
            vXMLHttpLoginRequest.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vLoginInfoResponse = vXMLHttpLoginRequest.responseText;
                    
                    var vLoginInfo = JSON.parse(vLoginInfoResponse);

                    if(vLoginInfo.length > 0) {
                        alert("Đăng nhập thành công.");
                    } else {
                        alert("Đăng nhập thất bại.");
                    }
                }
            }
        }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function validateForm(paramEmail, paramPassword) {
        if(!paramEmail.includes("@")) {
            alert("Email không đúng định dạng");
            return false;
        }

        if(paramPassword.length < 8) {
            alert("Độ dài mật khẩu phải lớn hơn hoặc bằng 8");
            return false;
        }

        return true;
    }
</script>

</html>